#!/usr/bin/perl

require ('cgi-lib.pl');
####################################################################
#                                                                  #
#  CC_GUESTBOOK BY CGI CITY IS A VERY SIMPLE GUESTBOOK PROGRAM.    #
#  IT FEATURES EMAIL NOTIFICATION SO THE GUESTBOOK OWNER IS        #
#  INFORMED WHENEVER THERE ARE NEW ENTRIES TO HIS/HER GUESTBOOK.   #
#  THIS SCRIPT CAN ALSO BE USED AS A "POST IT" BOARD WHERE         #
#  VISITORS CAN SIMPLY POST MESSAGES.                              #
#                                                                  #
#  THIS PROGRAM MAY BE USED AND DISTRIBUTED FREELY PROVIDED        #
#  NO MODIFICATIONS ARE MADE TO THE CODE.                          #
#                                                                  #
#  Copyright (c) 1998-1999 - CGI City - All rights reserved        #
#  Author: Peter N. Go - cgicity@icthus.net                        #
#                                                                  #
####################################################################
#                                                                  #
#  DISCLAIMER:                                                     #
#  In no event will CGI City be liable to the user of this script  #
#  or any third party for any damages, including any lost profits, #
#  lost savings or other incidental, consequential or special      #
#  damages arising out of the operation of or inability to operate #
#  this script, even if user has been advised of the possibility   #
#  of such damages.                                                #
#                                                                  #
####################################################################

####################################################################
#                                                                  #
#  INSTRUCTIONS:                                                   #
#  1. Modifiez la premire ligne de ce script pour pointer sur     #
#     l'interprteur perl de votre hebergeur.                      #
#  2. En dessous de la section ASSIGNATION DES VARIABLES ci dessous#
#     modifiez les chemins d'accs                                 #
#  3. Uploadez ce script vers votre rpertoire cgi-bin et rendez   #
#     le excutable (chmod 777)                                    #
#  4. Upalodez le fichier "guestbook_view.html" dans un rpertoire #
#     de votre choix sur votre serveur web. Ce rpertoire et ce    #
#     fichier doivent tous 2 etre chmod 777                        #
#                                                                  #
####################################################################

####################################################################
# Traduction du script effectue par http://www.scripts-fr.com/        #
# Scripts-fr.com n'est pas l'auteur de ce script. Tous les droits      #
# d'utilisation appartiennent a son auteur, mentionn dans le      #
# copyright original.                                              #
####################################################################

#############################
## ASSIGNATION DES VARIABLES
#############################

##  Changer la ligne suivant pour pointer vers le programme sendmail
$mailprog = '/usr/bin/sendmail';

##  Indiquez ci dessous l'url de votre guestbook
$guestbook_url = "http://www.scripts-fr.com/scripts/livresdor/cc_guestbook/guestbook_view.html";

##  Changez la ligne ci dessous pour pointer vers le fichier
$guestbook_file = "../www/scripts/livresdor/cc_guestbook/guestbook_view.html" ;

##  Indiquez votre adresse mail sans oublier de mettre un \ devant le @
##  C'est a cette adresse que vous recevrez les mails vous signalant l'ajout d'un message
$my_email = "scripts-fr\@scripts-fr.com";

##  Indiquez ci dessous le message d'erreur que vous souhaitez voir apparaitre en cas de problmes
$message = "L'erreur suivante s'est produite lors du traitement de votre demande." ;


####################################
## NE RIEN CHANGER APRES CES LIGNES
####################################

&ReadParse(*field);
$name = $field{'name'} ;	 
$email = $field{'email'} ;	 
$homepage_title = $field{'homepage_title'} ;	 
$homepage_url = $field{'homepage_url'} ;	 
$main_message = $field{'main_message'} ;	 
$found_err = "" ;
$getdate = `date +"%D %T %Z"`; 
chop ($getdate);

#####################################################
#  IF THERE ARE MISSING ENTRIES, PRINT ERROR MESSAGE
#####################################################
$errmsg = "<LI>Vous avez oubli d'introduire votre nom.</LI>\n" ;
if ($name eq "") {
	$message = $message.$errmsg ;
	$found_err = 1 ; }
$errmsg = "<LI>Introduisez une adresse mail valide svp</LI>\n" ;
if ($email !~ /.+\@.+\..+/) {
	$message = $message.$errmsg ;
	$found_err = 1 ; }
$errmsg = "<LI>Introduisez le titre de votre homepage</LI>\n" ;
if ($homepage_title eq "") {
	$message = $message.$errmsg ;
	$found_err = 1 ; }
$errmsg = "<LI>Laissez nous l'url de votre site svp :).</LI>\n" ;
if ($homepage_url eq "") {
	$message = $message.$errmsg ;
	$found_err = 1 ; }
if ($found_err) {
	&PrintError; }

########################################
#  PRINT  ENTRIES TO THE GUESTBOOK PAGE
########################################
open (FILE,"$guestbook_file") || die "Can't Open $guestbook_file: $!\n";
@lines = <FILE>;
close(FILE);

flock(POST, 2) ;
open (POST,">$guestbook_file") || die "Can't Open $guestbook_file: $!\n";
$main_message =~ s/&/&amp;/g;
$main_message =~ s/"/&quot;/g;
$main_message =~ s/>/&gt;/g;
$main_message =~ s/</&lt;/g;
$main_message =~ s/\cM\n/<BR>/g;

foreach $line (@lines) {
	if ($line =~ /<!--begin-->/) { 
	print POST "<!--begin-->\n";
	print POST "<DIR> \n";
	print POST "<FONT COLOR=\"#FF0000\"><B>Nom :</B></FONT> <A HREF=MAILTO:$email>$name</A><BR> \n";
	print POST "<FONT COLOR=\"#FF0000\"><B>Homepage :</B></FONT> <A HREF=$homepage_url>$homepage_title</A><BR> \n";
	print POST "<FONT COLOR=\"#FF0000\"><B>Date :</B></FONT> $getdate<BR> \n";
	print POST "<FONT COLOR=\"#FF0000\"><B>Message :</B></FONT><BR>$main_message</DIR><HR WIDTH=90%><BR> \n";
	} else {
		print POST ("$line");
	}
}
close (POST);
flock(POST, 8) ;
&success;
&notify;

######################
#  PRINT SUCCESS PAGE
######################
sub success {
print "Content-type: text/html\n\n";
print<<"end1";
<HTML>
<BODY BGCOLOR=WHITE>
<CENTER>
<H1>Merci d'avoir sign mon livre d'or</H1>
<A HREF=$guestbook_url>Voir le livre d'or</A>
</BODY>
</HTML>
end1
}

######################
#  NOTIFY BY EMAIL
######################
sub notify  {
	open (MAIL,"|$mailprog -t");
	print MAIL "To: $my_email\n";
	print MAIL "From: Guestbook Notification System\n";
	print MAIL "Subject: Nouveau message dans votre guestbook\n";
	print MAIL "Un nouveau message a t post par $name\n";
	print MAIL "a partir de l'IP - $ENV{'REMOTE_HOST'} \n";
	print MAIL "Vous pouvez le voir  l'adresse : $guestbook_url\n";
	close (MAIL);
exit;
}

#########################
#  OUTPUT ERROR MESSAGE
#########################
sub PrintError { 
print "Content-type: text/html\n\n";
print "<HTML><TITLE>Error!</TITLE></HEAD><BODY BGCOLOR=\"#FFFFFF\">\n\n";
print "<OL><H2>\n";
print $message;
print "</OL></H2></BODY></HTML>";

exit 0 ;
return 1 ; 
}

